/* Kg-sstar.c - Released To The Public Domain */
/* also added pipe_printf(), what a deal! =)  */
/* Scaling Star Field By KaRNaGE [oPP]        */
/* Compiled With Borland Turbo C++ 3.00       */
/* Compiled With Large Memory Module          */
/* Set Tab Spaces to 2                        */
/* Don't Be A LAMER!!! DON'T RIP, LEARN!!!    */
/* I'm NOT responsible for anything this program does execpt take up space */
/* If you don't like my indentation style, Fix it yo damn self!     */
/* if you USE MY CODE credit me in your work! or just give me a greet =) */

/* idea: try making the star field multi-layerd/multi-speed         */
/*       rotate the star field on the x,y,z axis...via cos and sin  */
/*       do something kewl...dunno =)                               */


#include <stdarg.h> /* va_??? functions   */
#include <stdlib.h> /* randomize, random  */
#include <conio.h>  /* kbhit              */
#include <stdio.h>  /* printf             */
#include <alloc.h>  /* farmalloc          */
#include <mem.h>    /* _fmempcy, _fmemset */
#include <dos.h>    /* exit, outportb     */


#define MAXSTARS     500  /* Number Of Stars          */
#define MAX_ZDEPTH   800  /* Max Depth Of Z Cordinate */
#define DIST         400  /* The "Distance" Away / How 'deep' your screen is */


unsigned char far *vid_seg = (unsigned char far *)0xA0000000L; /* Vid Address */
unsigned char far *vir_seg; /* virutal seg    */
int num_stars = 0;          /* Current Number Of Stars */


/* Stars Struct */
struct star_struct
{
	int x; /* x coordinate */
	int y; /* y coordinate */
	int z; /* z coordinate */
} stars[MAXSTARS];



/* Vertical Retrace */
void vretrace(void)
{
	while(inportb(0x3da) & 8);
	while(!(inportb(0x3da) & 8));
}



/* Set Video Modes */
void set_mode(int mode)
{
	asm{
		mov ax, mode
		int 10h
	}
}



/* flip buffer to screen */
void flip(unsigned char far *buffer)
{
  _fmemcpy(vid_seg, buffer, 64000);
}



/* set buffer to all black '0' */
void cls(unsigned char far *buffer)
{
  _fmemset(buffer, 0, 64000);
}



/* init the virtual seg */
void init_buffer(void)
{
  if ((vir_seg = (unsigned char far *)farmalloc((long)64000)) == NULL)
  {
    set_mode(0x03); /* set text mode */
    printf("Error Allocating 64000 Bytes In Function: init_buffers()");
    exit(-1);
  }
}



/* put a pixel to the buffer */
void putpixel(int x, int y, int color, unsigned char far *buffer)
{
  /* This Is Faster Then [y*320+x], cuz shifts are faster than Multiplying */
	buffer[((y << 8) + (y << 6)) + x] = color;
}



/* draw stars to the virtual buffer */
void draw_stars(void)
{
  int i = 0, x, y;

  /* if a star was deleted insert a new star */
  while (num_stars < MAXSTARS)
  {
    if (!stars[i].z) /* if star is dead */
    {
      stars[i].z = MAX_ZDEPTH;
      stars[i].x = random(320+1);
      stars[i].y = random(200+1);
      num_stars++;
    }
    i++;
  }

	/* Plot The Stars */
	for (i = 0; i < MAXSTARS; i++)
  {
    stars[i].z -= 3; /* make star closer / this is the speed of the stars */
    /* convert 3d to 2d */
 	  x = (int)((stars[i].x * DIST) / stars[i].z + 160);
	  y = (int)((stars[i].y * DIST) / stars[i].z + 120);
    /* check the boundries */
    if ((x <= 320) && (x >= 0) && (y <= 200) && (y >= 0) && (stars[i].z > 3))
      putpixel(x, y, (int)35 + stars[i].z / 27, vir_seg); /* divide by 27 makes the color darker */
    else /* kill star */
    {
      stars[i].z = 0;
      num_stars--;
    }
  }
}


/* make a random starfield / pre-calculate */
void make_stars(void)
{
  int i = 0;
  for(; i < MAXSTARS; i++)
  {
    stars[i].z = random(MAX_ZDEPTH) + 20; /* the 20 fixes a divide by 0 error =) */
    stars[i].x = random(320 - 1) + 1;
    stars[i].y = random(200 - 1) + 1;
    num_stars++;
  }
}



/* Make A Palette For The Star Field */
void setpal(void)
{
  int i = 256;
  outportb(0x3c8, 0);    /* Color To Start At 0 */
  for (; i > 0; i--)     /* i -= 2 also looks good */
  {
    outportb(0x3c9, i);  /* write color red   */
    outportb(0x3c9, i);  /* write color blue  */
    outportb(0x3c9, i);  /* write color green */
  }
}


/* pipe code printf by KaRNaGE [oPP] */
/* i don't know all that mutch about pipecodes but i think it's accurate =) */
void pipe_printf(unsigned char far *text, ...)
{
   va_list ap;                           /* point to arg list */
   unsigned int      i = 0;              /* index */
   unsigned char     tempbuf[2];         /* temp buf */
   unsigned int      c;                  /* color */
   unsigned char far *buffer;            /* new buffer */

   va_start(ap, text);                   /* set up the arg list */
   buffer = (unsigned char far *)farmalloc(_fstrlen(text) + 100);
   vsprintf(buffer, text, ap);           /* copy all the args to buffer */
   while (i < _fstrlen(buffer))
   {
     if (buffer[i] == '|')              /* parse pipe code */
     {
       _fstrncpy(tempbuf, &buffer[i+1], 2); tempbuf[2] = '\0';
       if ((c = atoi(tempbuf)) >= 1 && c <= 16)
       {
         textcolor(c);
         i += 3;
       }
       else if (c >= 17 && c <= 23)
       {
         textbackground(c - 16);
         i += 3;
       }
       else cprintf("%c", buffer[i++]);
     }
     else cprintf("%c", buffer[i++]);
   }
   farfree(buffer); /* free buffer  */
   va_end(ap);      /* free pointer */
}



void main(void)
{
  randomize();      /* Make Sure it's 'random'                */
  set_mode(0x13);   /* Set mode 13h 320x200x256 Graphics Mode */
  make_stars();     /* make 'random' star field               */
  setpal();         /* set the palette                        */
  init_buffer();    /* farmalloc the vir_seg                  */
	while (!kbhit())  /* Keep On Going Until User Hits A Key    */
	{
    cls(vir_seg);   /* clear the vir_seg                      */
 		draw_stars();   /* Do The stars                           */
    flip(vir_seg);  /* flip the vir_seg to the screen         */
		vretrace();     /* Vertical Retrace To Make It Smooth     */
	}
	set_mode(0x03);   /* Go Back To 80x25x16 Text Mode          */
  farfree(vir_seg); /* free the memory from the vir_seg       */
  while (kbhit()) getch(); /* Get Rid Of All Key Presses      */

  /* Give CREDIT to the person who made it =) and give an pipe example */
  /* also show that the %d %s crap works too                           */
  pipe_printf("|15K|09o|01DeD By KaRNaGE [oP|09P|15] |22On |15|18%s|09|20/%s|01|21/%d|15", "06", "05", 95);

  exit(0);          /* exit to dos - this isn't really needed though =) */
}